import { computed as s, onMounted as M, ref as A, watch as N, openBlock as i, createElementBlock as c, normalizeStyle as d, toDisplayString as y, createCommentVNode as f, unref as r, createElementVNode as v, normalizeClass as D, createBlock as E } from "vue";
import { u as G, o as I, e as S, g as U, c as q, t as P, M as R, X as T, i as X, v as g, f as H } from "./index-B6m-GhsP.js";
import { u as z } from "./useNestedProp-BrcBWysp.js";
import Y from "./vue-ui-skeleton-BOhyMEA5.js";
const J = ["xmlns", "viewBox"], K = ["id"], Q = ["stop-color"], V = ["stop-color"], W = ["d", "stroke", "stroke-linecap"], Z = ["d", "stroke", "stroke-linecap", "stroke-dashoffset"], ee = ["x", "y", "font-size", "fill", "font-weight"], se = {
  __name: "vue-ui-sparkgauge",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  setup(F) {
    const l = F, { vue_ui_sparkgauge: O } = G(), p = s(() => !!l.dataset && Object.keys(l.dataset).length);
    M(() => {
      h();
    });
    function h() {
      I(l.dataset) ? S({
        componentName: "VueUiSparkgauge",
        type: "dataset"
      }) : U({
        datasetObject: l.dataset,
        requiredAttributes: ["value", "min", "max"]
      }).forEach((t) => {
        S({
          componentName: "VueUiSparkgauge",
          type: "datasetAttribute",
          property: t
        });
      });
    }
    const b = A(q()), e = s({
      get: () => k(),
      set: (t) => t
    });
    function k() {
      const t = z({
        userConfig: l.config,
        defaultConfig: O
      });
      return t.theme ? {
        ...z({
          userConfig: P.vue_ui_sparkgauge[t.theme] || l.config,
          defaultConfig: t
        })
      } : t;
    }
    N(() => l.config, (t) => {
      e.value = k(), h();
    }, { deep: !0 });
    const u = s(() => ({
      height: e.value.style.height,
      width: 128,
      base: e.value.style.basePosition
    })), o = s(() => {
      const t = l.dataset.min ?? 0, n = l.dataset.max ?? 0, B = n - t;
      return {
        min: t,
        max: n,
        diff: B
      };
    }), a = A(e.value.style.animation.show ? o.value.min : l.dataset.value);
    N(() => l.dataset.value, () => {
      C(l.dataset.value || 0);
    });
    const x = s(() => a.value > o.value.max ? o.value.max : a.value < o.value.min ? o.value.min : a.value), _ = s(() => o.value.diff / e.value.style.animation.speedMs);
    M(() => {
      C(l.dataset.value || 0);
    });
    function C(t) {
      function n() {
        a.value < t ? a.value = Math.min(a.value + _.value, t) : a.value > t && (a.value = Math.max(a.value - _.value, t)), a.value !== t && requestAnimationFrame(n);
      }
      n();
    }
    const m = s(() => l.dataset.title ?? ""), $ = s(() => a.value >= 0 ? (x.value - o.value.min) / o.value.diff : (Math.abs(o.value.min) - Math.abs(x.value)) / o.value.diff), w = s(() => R(e.value.style.colors.min, e.value.style.colors.max, o.value.min, o.value.max, a.value)), L = s(() => e.value.style.dataLabel.autoColor ? w.value : e.value.style.dataLabel.color), j = s(() => e.value.style.track.autoColor ? w.value : e.value.style.track.color);
    return (t, n) => (i(), c("div", {
      style: d(`font-family:${e.value.style.fontFamily};width: 100%; background:${e.value.style.background}`)
    }, [
      e.value.style.title.show && m.value && e.value.style.title.position === "top" ? (i(), c("div", {
        key: 0,
        class: "vue-data-ui-sparkgauge-label",
        style: d(`font-size:${e.value.style.title.fontSize}px;text-align:${e.value.style.title.textAlign};font-weight:${e.value.style.title.bold ? "bold" : "normal"};color:${e.value.style.title.color}`)
      }, y(m.value), 5)) : f("", !0),
      p.value ? (i(), c("svg", {
        key: 1,
        xmlns: r(T),
        viewBox: `0 0 ${u.value.width} ${u.value.height}`,
        style: d(`overflow: visible; background:${e.value.style.background}; width:100%;`)
      }, [
        v("defs", null, [
          v("linearGradient", {
            id: `gradient_${b.value}`,
            x1: "-10%",
            y1: "100%",
            x2: "110%",
            y2: "100%"
          }, [
            v("stop", {
              offset: "0%",
              "stop-color": e.value.style.colors.min
            }, null, 8, Q),
            v("stop", {
              offset: "100%",
              "stop-color": e.value.style.colors.max
            }, null, 8, V)
          ], 8, K)
        ]),
        v("path", {
          d: `M10 ${u.value.base} A 1 1 0 1 1 118 ${u.value.base}`,
          stroke: e.value.style.gutter.color,
          "stroke-width": 8,
          "stroke-linecap": e.value.style.gutter.strokeLinecap,
          fill: "none"
        }, null, 8, W),
        $.value !== 0 ? (i(), c("path", {
          key: 0,
          d: `M10 ${u.value.base} A 1 1 0 1 1 118 ${u.value.base}`,
          stroke: e.value.style.colors.showGradient ? `url(#gradient_${b.value})` : j.value,
          "stroke-width": 8,
          "stroke-linecap": e.value.style.track.strokeLinecap,
          fill: "none",
          "stroke-dasharray": 169.5,
          "stroke-dashoffset": 169.5 - 169.5 * $.value,
          class: D({ "vue-ui-sparkgauge-track": e.value.style.animation.show }),
          style: d(e.value.style.animation.show ? `animation: vue-ui-sparkgauge-animation ${e.value.style.animation.speedMs}ms ease-in;` : "")
        }, null, 14, Z)) : f("", !0),
        v("text", {
          "text-anchor": "middle",
          x: u.value.width / 2,
          y: u.value.base + 6 + e.value.style.dataLabel.offsetY,
          "font-size": e.value.style.dataLabel.fontSize,
          fill: L.value,
          "font-weight": e.value.style.dataLabel.bold ? "bold" : "normal"
        }, y(r(X)(
          e.value.style.dataLabel.formatter,
          r(g)(a.value),
          r(H)({
            p: e.value.style.dataLabel.prefix,
            v: r(g)(a.value),
            s: e.value.style.dataLabel.suffix,
            r: e.value.style.dataLabel.rounding
          }),
          { datapoint: r(g)(a.value), color: L.value }
        )), 9, ee)
      ], 12, J)) : f("", !0),
      p.value ? f("", !0) : (i(), E(Y, {
        key: 2,
        config: {
          type: "gauge",
          style: {
            backgroundColor: e.value.style.background,
            gauge: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      e.value.style.title.show && m.value && e.value.style.title.position === "bottom" ? (i(), c("div", {
        key: 3,
        class: "vue-data-ui-sparkgauge-label",
        style: d(`font-size:${e.value.style.title.fontSize}px;text-align:${e.value.style.title.textAlign};font-weight:${e.value.style.title.bold ? "bold" : "normal"};font-weight:${e.value.style.title.bold ? "bold" : "normal"};color:${e.value.style.title.color}`)
      }, y(m.value), 5)) : f("", !0)
    ], 4));
  }
};
export {
  se as default
};
